
import random, sys, traceback

# Pymsrpc imports


from rpc import *
from ndr import *
from parse import parse_idl
from debug import print_hex, dump_ndr

def usage():
    print "%s <idl filename> [host] [pipe] [opnum]" % sys.argv[0]
    sys.exit(-1)

    
DEBUG = True

send = False
do_context = False

filename = sys.argv[1]
opnum = False

if len(sys.argv) > 2:
    host = sys.argv[2]
    port = 445
    pipe = sys.argv[3]

    if len(sys.argv) == 5:
        opnum = int(sys.argv[4])
    
    send = True

    
idl = parse_idl(filename)
rpc = None

uuid = idl[0]
if not idl:
    print "[!] idl parsing problem."
    sys.exit(-1)
    





for opcode in uuid.opcodes:
    print "*"*50
    print "**Testing "+str(opcode.opnum)
    
    try:
        
        print opcode.elements
        test_cases=[]
        for i in range(0,len(opcode.elements)):
            
            data_type = type(opcode.elements[i])
            if(getattr(opcode.elements[i],"get_fuzz_list", None) != None):
                    fuzz_list = data_type.get_fuzz_list()
                    for item in fuzz_list:
                        test_case = list(opcode.elements)
                        test_case[i]=item
                        test_cases.append(test_case)
        
        print "Total number of test cases:"+str(len(test_cases))
        
        for test_case in test_cases:
            
            try:
                print "-"*50
                print "[*] Connecting ncacn_np to [%s:\\\\PIPE\\%s]" % (host, pipe)
                rpc = RPCnp(host, port, pipe, username="test", password="test")
                rpc.connect()

                print "[*] Binding to [%s][%s]" % (uuid.ifid, uuid.version)
                rpc.bind(uuid.ifid, uuid.version)
                
                opcode.elements=test_case
                #if(len(opcode.elements)>= 1):
                #    opcode.elements[0]=ndr_full(data=ndr_wstring(data="\x41"*50500))
                request=""
                # This is all you do to serialize the data for the wire    
                request += opcode.serialize()
                
                print "Request="+request.encode("hex")
                            
                rpc.call(opcode.opnum, request)
                            
                try:
                    recvbuffer = rpc.recv()
                except Exception as e1:
                    print "[!] Socket closed skipping uuid"
                    print "Exception:"+str(e1)
                    rpc = None
                    

                if recvbuffer:
                    print "Received buffer="+recvbuffer.encode('hex')
                    try:
                        rpcerror = rpc.rpcerror(struct.unpack("<L", recvbuffer[:4])[0])
                    except Exception as e2:
                        print "[!] Problem with unpack of [%s]" % (recvbuffer)
                        
                        
                    if not rpcerror:
                        print "[*] Received [%s]" % print_hex(recvbuffer)
                    else:
                        print "[!] RPC Error [%s]" % (rpcerror)
                        if rpcerror == "rpc_x_bad_stub_data":
                            # AAAAAAAAAAAHHHHHHHHHHHHHHHHHHHHHHHHHH!
                            raw_input("bad stub> ")
            except Exception as e4:
                print "Skipping test case"
                print e4
    except Exception as e3:
        print "Error testing "+str(opcode.opnum)
        print e3
        traceback.print_exc()